searchNodes=[{"doc":"Rewire is a libary for replacing hard-wired dependencies of the module your unit testing. This keeps your production code free from any unit testing-specific concerns.UsageGiven a module such as this:# this module has a hard-wired dependency on the `English` module defmodule Conversation do def start(), do: English.greet() endIf you define a mox mock EnglishMock you can rewire the dependency in your unit test:defmodule MyTest do use ExUnit.Case import Rewire # (1) activate `rewire` import Mox rewire Conversation, English: EnglishMock # (2) rewire `English` to `EnglishMock` test &quot;start/0&quot; do stub(EnglishMock, :greet, fn -&gt; &quot;g&#39;day&quot; end) assert Conversation.start() == &quot;g&#39;day&quot; # (3) test using the mock end endThis example uses mox, but rewire is mocking library-agnostic.You can use multiple rewires and multiple overrides: rewire Conversation, English: EnglishMock rewire OnlineConversation, Email: EmailMock, Chat: ChatMockYou can also give the alias a different name using as: rewire Conversation, English: EnglishMock, as: SmallTalkAlternatively, you can also rewire a module inside a block: rewire Conversation, English: EnglishMock do # (1) only rewired inside the block stub(EnglishMock, :greet, fn -&gt; &quot;g&#39;day&quot; end) assert Conversation.start() == &quot;g&#39;day&quot; # (2) test using the mock end","ref":"Rewire.html","title":"Rewire","type":"module"},{"doc":"Macro that allows to rewire (and alias) a module.import Rewire rewire App.ModuleToRewire, ModuleDep: Mock # `ModuleToRewire` will use `Mock` now endOptionsopts is a keyword list:as - give the rewired module a different nameany other item, like ModuleDep: Mock, will be interpreted as a mapping from one module to another","ref":"Rewire.html#rewire/2","title":"Rewire.rewire/2","type":"macro"}]